
local M = {}

local nl33
local nl32


local cooldown
local lastCheckedFireValue -- allows using an input device axis as shooting control, not just on/off buttons

local function onReset()
  electrics.values['lifter'] = 0
  electrics.values['lifter_input'] = 0
  electrics.values['shoot'] = 0
  cooldown = 0
  lastCheckedFireValue = 0
  for k, node in pairs (v.data.nodes) do
    if node.name == "nl33" then nl33=k  end
    if node.name == "nl32" then nl32=k  end
  end
end

local function updateGFX(dt) -- ms
  electrics.values['lifter'] = math.min(1, math.max(-0.0, (electrics.values['lifter'] + electrics.values['lifter_input'] * dt * 0.1)))
  if electrics.values['shoot'] == 0 then
    if math.random(0, 1) < (1+cooldown*0.9) then -- cannon smoke & fire for 500 ms
       obj:addParticleByNodesRelative(nl33, nl33, 1, 9, 0.01, 1)	
       obj:addParticleByNodesRelative(nl32, nl32, 1, 51, 0.01, 1)	   
    end
    cooldown = cooldown + dt
  end
end



local function liftBarrel(value)
  electrics.values.lifter_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.fire      = fire
M.liftBarrel = liftBarrel

return M